Texture2D tex0 <string uiname="Texture";>;

SamplerState s0 <bool visible=false;string uiname="Sampler";>
{Filter=MIN_MAG_MIP_LINEAR;AddressU=WRAP;AddressV=WRAP;};

cbuffer cbControls:register(b0){
	float4x4 tWVP:WORLDVIEWPROJECTION;
	float4x4 tVP:VIEWPROJECTION;
	float4x4 tW:WORLD;
	float4x4 tV:VIEW;
	float4x4 tP:PROJECTION;
	float4x4 tWI:WORLDINVERSE;
	float4x4 tVI:VIEWINVERSE;
	float4x4 tPI:PROJECTIONINVERSE;
	float4x4 tWIT:WORLDINVERSETRANSPOSE;
	//float Alpha <float uimin=0.0; float uimax=1.0;> = 1; 
};

struct VS_IN{
	uint id:SV_VertexID;
};

struct VS_OUT{
	float4 PosWVP:SV_POSITION;
	float4 TexCd:TEXCOORD0;
	float4 PosW:TEXCOORD1;
};
int2 GridSize=32;
VS_OUT VS(VS_IN In){
	VS_OUT Out=(VS_OUT)0;
	int2 vp=int2(In.id%GridSize.x,In.id/GridSize.x);
	
	float4 PosW=float4((float2(vp-(GridSize-int2(1,0))*.5)/GridSize)*2,0,1);
	Out.TexCd=float4(PosW.xy*.5*float2(1,-1)+.5,0,1);
	Out.TexCd.y-=.5/GridSize.y;
	
	PosW=mul(PosW,tW);
	Out.PosWVP=mul(PosW,tVP);
	
	Out.PosW=PosW;
	return Out;
}

[maxvertexcount(3)]
void GSt(triangle VS_OUT In[3], inout TriangleStream<VS_OUT> GSOut)
{
	VS_OUT o;
	for(int i=0;i<3;i++){
		o=In[i];
		GSOut.Append(o);
	}
}

[maxvertexcount(1)]
void GS(point VS_OUT In[1], inout PointStream<VS_OUT> GSOut)
{
	VS_OUT o;
	o=In[0];
	GSOut.Append(o);
}
float4 PS(VS_OUT In):SV_Target{
	float4 c=tex0.Sample(s0,In.TexCd.xy);
	
	return c;
}


technique10 Normal{
	pass P0{
		SetVertexShader(CompileShader(vs_5_0,VS()));
		SetGeometryShader(CompileShader(gs_5_0,GS()));
		SetPixelShader(CompileShader(ps_5_0,PS()));
	}
}




